<?php

/* ***********************************************************
 * This file was automatically generated on 2014-08-11.      *
 *                                                           *
 * Bindings Version 2.1.2                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Device for measuring color (RGB value), illuminance and color temperature
 */
class BrickletColor extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletColor::setColorCallbackPeriod(). The parameter is the color
     * of the sensor as RGBC.
     * 
     * BrickletColor::CALLBACK_COLOR is only triggered if the color has changed since the
     * last triggering.
     */
    const CALLBACK_COLOR = 8;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletColor::setColorCallbackPeriod(). The parameter is the color
     * of the sensor as RGBC.
     * 
     * BrickletColor::CALLBACK_COLOR is only triggered if the color has changed since the
     * last triggering.
     */
    const CALLBACK_COLOR_REACHED = 9;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletColor::setIlluminanceCallbackPeriod(). The parameter is the illuminance.
     * See BrickletColor::getIlluminance() for how to interrept this value.
     * 
     * BrickletColor::CALLBACK_ILLUMINANCE is only triggered if the illuminance has changed since the
     * last triggering.
     */
    const CALLBACK_ILLUMINANCE = 21;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletColor::setColorTemperatureCallbackPeriod(). The parameter is the 
     * color temperature in Kelvin.
     * 
     * BrickletColor::CALLBACK_COLOR_TEMPERATURE is only triggered if the color temperature has 
     * changed since the last triggering.
     */
    const CALLBACK_COLOR_TEMPERATURE = 22;


    /**
     * @internal
     */
    const FUNCTION_GET_COLOR = 1;

    /**
     * @internal
     */
    const FUNCTION_SET_COLOR_CALLBACK_PERIOD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_COLOR_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_COLOR_CALLBACK_THRESHOLD = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_COLOR_CALLBACK_THRESHOLD = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 7;

    /**
     * @internal
     */
    const FUNCTION_LIGHT_ON = 10;

    /**
     * @internal
     */
    const FUNCTION_LIGHT_OFF = 11;

    /**
     * @internal
     */
    const FUNCTION_IS_LIGHT_ON = 12;

    /**
     * @internal
     */
    const FUNCTION_SET_CONFIG = 13;

    /**
     * @internal
     */
    const FUNCTION_GET_CONFIG = 14;

    /**
     * @internal
     */
    const FUNCTION_GET_ILLUMINANCE = 15;

    /**
     * @internal
     */
    const FUNCTION_GET_COLOR_TEMPERATURE = 16;

    /**
     * @internal
     */
    const FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD = 17;

    /**
     * @internal
     */
    const FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD = 18;

    /**
     * @internal
     */
    const FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD = 19;

    /**
     * @internal
     */
    const FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD = 20;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';
    const LIGHT_ON = 0;
    const LIGHT_OFF = 1;
    const GAIN_1X = 0;
    const GAIN_4X = 1;
    const GAIN_16X = 2;
    const GAIN_60X = 3;
    const INTEGRATION_TIME_2MS = 0;
    const INTEGRATION_TIME_24MS = 1;
    const INTEGRATION_TIME_101MS = 2;
    const INTEGRATION_TIME_154MS = 3;
    const INTEGRATION_TIME_700MS = 4;

    const DEVICE_IDENTIFIER = 243;

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_COLOR] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_COLOR_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_COLOR_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_COLOR_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_COLOR_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_COLOR] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_COLOR_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_LIGHT_ON] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_LIGHT_OFF] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_IS_LIGHT_ON] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_CONFIG] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_CONFIG] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ILLUMINANCE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_COLOR_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_ILLUMINANCE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_COLOR_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_COLOR] = 'callbackWrapperColor';
        $this->callbackWrappers[self::CALLBACK_COLOR_REACHED] = 'callbackWrapperColorReached';
        $this->callbackWrappers[self::CALLBACK_ILLUMINANCE] = 'callbackWrapperIlluminance';
        $this->callbackWrappers[self::CALLBACK_COLOR_TEMPERATURE] = 'callbackWrapperColorTemperature';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the measured color of the sensor. The values
     * have a range of 0 to 65535.
     * 
     * The red (r), green (g), blue (b) and clear (c) colors are measured
     * with four different photodiodes that are responsive at different
     * wavelengths:
     * 
     * .. image:: /Images/Bricklets/bricklet_color_wavelength_chart_600.jpg
     *    :scale: 100 %
     *    :alt: Chart Responsivity / Wavelength
     *    :align: center
     *    :target: ../../_images/Bricklets/bricklet_color_wavelength_chart_600.jpg
     * 
     * If you want to get the color periodically, it is recommended 
     * to use the callback BrickletColor::CALLBACK_COLOR and set the period with 
     * BrickletColor::setColorCallbackPeriod().
     * 
     * 
     * @return array
     */
    public function getColor()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COLOR, $payload);

        $payload = unpack('v1r/v1g/v1b/v1c', $data);

        $result['r'] = $payload['r'];
        $result['g'] = $payload['g'];
        $result['b'] = $payload['b'];
        $result['c'] = $payload['c'];

        return $result;
    }

    /**
     * Sets the period in ms with which the BrickletColor::CALLBACK_COLOR callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletColor::CALLBACK_COLOR is only triggered if the color has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setColorCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_COLOR_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletColor::setColorCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getColorCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COLOR_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletColor::CALLBACK_COLOR_REACHED callback. 
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0, 0, 0, 0, 0, 0, 0).
     * 
     * @param string $option
     * @param int $min_r
     * @param int $max_r
     * @param int $min_g
     * @param int $max_g
     * @param int $min_b
     * @param int $max_b
     * @param int $min_c
     * @param int $max_c
     * 
     * @return void
     */
    public function setColorCallbackThreshold($option, $min_r, $max_r, $min_g, $max_g, $min_b, $max_b, $min_c, $max_c)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('v', $min_r);
        $payload .= pack('v', $max_r);
        $payload .= pack('v', $min_g);
        $payload .= pack('v', $max_g);
        $payload .= pack('v', $min_b);
        $payload .= pack('v', $max_b);
        $payload .= pack('v', $min_c);
        $payload .= pack('v', $max_c);

        $this->sendRequest(self::FUNCTION_SET_COLOR_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletColor::setColorCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getColorCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COLOR_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/v1min_r/v1max_r/v1min_g/v1max_g/v1min_b/v1max_b/v1min_c/v1max_c', $data);

        $result['option'] = chr($payload['option']);
        $result['min_r'] = $payload['min_r'];
        $result['max_r'] = $payload['max_r'];
        $result['min_g'] = $payload['min_g'];
        $result['max_g'] = $payload['max_g'];
        $result['min_b'] = $payload['min_b'];
        $result['max_b'] = $payload['max_b'];
        $result['min_c'] = $payload['min_c'];
        $result['max_c'] = $payload['max_c'];

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callback
     * 
     * * BrickletColor::CALLBACK_COLOR_REACHED
     * 
     * is triggered, if the threshold
     * 
     * * BrickletColor::setColorCallbackThreshold()
     * 
     * keeps being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletColor::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * Turns the LED on.
     * 
     * 
     * @return void
     */
    public function lightOn()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_LIGHT_ON, $payload);
    }

    /**
     * Turns the LED off.
     * 
     * 
     * @return void
     */
    public function lightOff()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_LIGHT_OFF, $payload);
    }

    /**
     * Returns *true* if the backlight is on and *false* otherwise.
     * 
     * 
     * @return int
     */
    public function isLightOn()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_LIGHT_ON, $payload);

        $payload = unpack('C1light', $data);

        return $payload['light'];
    }

    /**
     * Sets the configuration of the sensor. Gain and integration time
     * can be configured in this way.
     * 
     * For configuring the gain:
     * 
     * * 0: 1x Gain
     * * 1: 4x Gain
     * * 2: 16x Gain
     * * 3: 60x Gain
     * 
     * For configuring the integration time:
     * 
     * * 0: 2.4ms
     * * 1: 24ms
     * * 2: 101ms
     * * 3: 154ms
     * * 4: 700ms
     * 
     * Increasing the gain enables the sensor to detect a
     * color from a higher distance.
     * 
     * The integration time provides a trade-off between conversion time
     * and accuracy. With a longer integration time the values read will
     * be more accurate but it will take longer time to get the conversion
     * results.
     * 
     * The default values are 60x gain and 154ms integration time.
     * 
     * @param int $gain
     * @param int $integration_time
     * 
     * @return void
     */
    public function setConfig($gain, $integration_time)
    {
        $payload = '';
        $payload .= pack('C', $gain);
        $payload .= pack('C', $integration_time);

        $this->sendRequest(self::FUNCTION_SET_CONFIG, $payload);
    }

    /**
     * Returns the configuration as set by BrickletColor::setConfig().
     * 
     * 
     * @return array
     */
    public function getConfig()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CONFIG, $payload);

        $payload = unpack('C1gain/C1integration_time', $data);

        $result['gain'] = $payload['gain'];
        $result['integration_time'] = $payload['integration_time'];

        return $result;
    }

    /**
     * Returns the illuminance affected by the gain and integration time as
     * set by BrickletColor::setConfig(). To get the illuminance in Lux apply this formula::
     * 
     *  lux = illuminance * 700 / gain / integration_time
     * 
     * To get a correct illuminance measurement make sure that the color
     * values themself are not saturated. The color value (R, G or B)
     * is saturated if it is equal to the maximum value of 65535.
     * In that case you have to reduce the gain, see BrickletColor::setConfig().
     * 
     * 
     * @return int
     */
    public function getIlluminance()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ILLUMINANCE, $payload);

        $payload = unpack('V1illuminance', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'illuminance');
    }

    /**
     * Returns the color temperature in Kelvin.
     * 
     * To get a correct color temperature measurement make sure that the color
     * values themself are not saturated. The color value (R, G or B)
     * is saturated if it is equal to the maximum value of 65535.
     * In that case you have to reduce the gain, see BrickletColor::setConfig().
     * 
     * 
     * @return int
     */
    public function getColorTemperature()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COLOR_TEMPERATURE, $payload);

        $payload = unpack('v1color_temperature', $data);

        return $payload['color_temperature'];
    }

    /**
     * Sets the period in ms with which the BrickletColor::CALLBACK_ILLUMINANCE callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletColor::CALLBACK_ILLUMINANCE is only triggered if the illuminance has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setIlluminanceCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletColor::setIlluminanceCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getIlluminanceCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickletColor::CALLBACK_COLOR_TEMPERATURE callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletColor::CALLBACK_COLOR_TEMPERATURE is only triggered if the color temperature has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setColorTemperatureCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_COLOR_TEMPERATURE_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletColor::setColorTemperatureCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getColorTemperatureCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_COLOR_TEMPERATURE_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $userData
     *
     * @return void
     */
    public function registerCallback($id, $callback, $userData = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $userData;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperColor($data)
    {
        $result = array();
        $payload = unpack('v1r/v1g/v1b/v1c', $data);

        array_push($result, $payload['r']);
        array_push($result, $payload['g']);
        array_push($result, $payload['b']);
        array_push($result, $payload['c']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_COLOR]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_COLOR], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperColorReached($data)
    {
        $result = array();
        $payload = unpack('v1r/v1g/v1b/v1c', $data);

        array_push($result, $payload['r']);
        array_push($result, $payload['g']);
        array_push($result, $payload['b']);
        array_push($result, $payload['c']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_COLOR_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_COLOR_REACHED], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperIlluminance($data)
    {
        $result = array();
        $payload = unpack('V1illuminance', $data);

        array_push($result, IPConnection::fixUnpackedUInt32($payload, 'illuminance'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ILLUMINANCE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ILLUMINANCE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperColorTemperature($data)
    {
        $result = array();
        $payload = unpack('v1color_temperature', $data);

        array_push($result, $payload['color_temperature']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_COLOR_TEMPERATURE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_COLOR_TEMPERATURE], $result);
    }
}

?>
